package explorviz.live_trace_processing.filter.reduction.summarization;

import java.util.ArrayList;
import java.util.List;

import explorviz.live_trace_processing.filter.IPipeReceiver;
import explorviz.live_trace_processing.filter.reduction.AbstractReductionFilter;
import explorviz.live_trace_processing.filter.reduction.ITraceReduction;
import explorviz.live_trace_processing.record.event.AbstractAfterEventRecord;
import explorviz.live_trace_processing.record.event.AbstractBeforeEventRecord;
import explorviz.live_trace_processing.record.event.AbstractEventRecord;
import explorviz.live_trace_processing.record.trace.Trace;

public class IterationFilter extends AbstractReductionFilter implements ITraceReduction {

	public IterationFilter(final IPipeReceiver receiver) {
		super(receiver, "IterationFilter");
	}

	@Override
	protected Trace reduceTrace(final Trace trace) {
		final List<AbstractEventRecord> newTraceEvents = new ArrayList<AbstractEventRecord>();
		final List<AbstractEventRecord> traceEvents = trace.getTraceEvents();
		int i = 0;
		while (i < (traceEvents.size() - 3)) {
			if (traceEvents.get(i) instanceof AbstractBeforeEventRecord) {
				final AbstractBeforeEventRecord firstBeforeEvent = (AbstractBeforeEventRecord) traceEvents
						.get(i);
				if (traceEvents.get(i + 1) instanceof AbstractAfterEventRecord) {
					final AbstractAfterEventRecord firstAfterEvent = (AbstractAfterEventRecord) traceEvents
							.get(i + 1);
					if (traceEvents.get(i + 2) instanceof AbstractBeforeEventRecord) {
						final AbstractBeforeEventRecord secondBeforeEvent = (AbstractBeforeEventRecord) traceEvents
								.get(i + 2);
						if (firstBeforeEvent.compareTo(secondBeforeEvent) == 0) {
							if (traceEvents.get(i + 3) instanceof AbstractAfterEventRecord) {
								secondBeforeEvent.getRuntimeStatisticInformation().makeAccumulator(
										0);
								secondBeforeEvent.getRuntimeStatisticInformation().merge(
										firstBeforeEvent.getRuntimeStatisticInformation(),
										firstBeforeEvent.getObjectId());
								i += 2;
							} else {
								newTraceEvents.add(firstBeforeEvent);
								newTraceEvents.add(firstAfterEvent);
								newTraceEvents.add(secondBeforeEvent);
								i += 3;
							}
						} else {
							newTraceEvents.add(firstBeforeEvent);
							newTraceEvents.add(firstAfterEvent);
							i += 2;
						}
					} else {
						newTraceEvents.add(firstBeforeEvent);
						newTraceEvents.add(firstAfterEvent);
						i += 2;
					}
				} else {
					newTraceEvents.add(firstBeforeEvent);
					i++;
				}
			} else {
				newTraceEvents.add(traceEvents.get(i));
				i++;
			}
		}
		while (i < traceEvents.size()) {
			newTraceEvents.add(traceEvents.get(i));
			i++;
		}
		final Trace reducedTrace = new Trace(newTraceEvents, true);
		return reducedTrace;
	}

}
